Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 155932 - [RHEL4-U2][Diskdump] hangs when SCSI drive is busy
Summary: [RHEL4-U2][Diskdump] hangs when SCSI drive is busy
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel
Version: 4.0
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Nobuhiro Tachino
QA Contact: Brian Brock
URL:
Whiteboard:
Depends On:
Blocks: 156322
TreeView+ depends on / blocked
 
Reported: 2005-04-25 20:50 UTC by Yuuichi Nagahama
Modified: 2010-10-22 02:55 UTC (History)
10 users (show)

Fixed In Version: RHSA-2005-514
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2005-10-05 13:03:07 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2005:514 qe-ready SHIPPED_LIVE Important: Updated kernel packages available for Red Hat Enterprise Linux 4 Update 2 2005-10-05 04:00:00 UTC

Description Yuuichi Nagahama 2005-04-25 20:50:37 UTC
Description of problem:
Diskdump doesn't check a SCSI command return value.
Please see send_command in drivers/scsi/scsi_dump.c.

spin_lock(host->host_lock);
host->hostt->queuecommand(scmd, rw_intr);   <<< here >>>
spin_unlock(host->host_lock);

while (scmd->done != NULL) {
       host->hostt->dump_poll(scmd->device);
       udelay(100);
       diskdump_update();
}

Diskdump waits for completion of the command invoked previously
regardless of a return value of queuecommand.

SCSI driver might return busy because of a temporary failure of SCSI
driver. If SCSI driver returns busy, diskdump waits for completion
of the command permanently. So diskdump will hang up.

I think diskdump should check a return value of queuecommand.
When SCSI drive is busy, a command should be invoked again.

Version-Release number :
kernel-2.6.9-5.0.3.EL

How reproducible:
sometimes

Steps to Reproduce:
This problem happens because of external factor.
For example, temporary trouble of device.

Actual results:
dump fail

Expected results:
dump succeed

Additional info:
none

Comment 13 Red Hat Bugzilla 2005-10-05 13:03:07 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2005-514.html



Note You need to log in before you can comment on or make changes to this bug.